      subroutine formbprojector(nbase,nos,nop,nod,nof,nog,n,h,mxnl,     &
        iiirc,r,nmx,mxo,phi,tphi,tp,rveff,veff0,eval,mxb,               &
        cp,ophi,otphi,otp,shape)
!  program to generate projector functions for Blochl's paw formalism
!    starting with smooth functions
!    for every basis function phi, choose smooth function with
!     form for r<rc: (r**(l+1))*sum(n)*(cn*(r**(2*n)))
!       where, rc==r(iiirc)
!  phi(i,io), eval(io), tocc(io)  original basis function, energy, occupancy
!  tphi(i,io) smooth basis function corresponding to phi(i,io)
!  tp(i,io)=constant*normalized Harmonic Oscillator function
!  tp == 0 for r>r(iiirc)
!  functions defined to be identically zero for r>r(iiirc))
      implicit real*8 (a-h,o-z)
      dimension r(nmx),shape(nmx)
      dimension eval(mxo),cp(mxo)
      dimension phi(nmx,mxo),tphi(nmx,mxo),tp(nmx,mxo)
      dimension ophi(nmx,mxo),otphi(nmx,mxo),otp(nmx,mxo)
      dimension rveff(nmx)
      dimension a(mxb,mxb),b(mxb,mxb)
!
!   form projector functions
!
      istart=1
      do l=0,4,1
       if (l.eq.0) many=nos
       if (l.eq.1) many=nop
       if (l.eq.2) many=nod
       if (l.eq.3) many=nof
       if (l.eq.4) many=nog
      if (many.gt.0) then
      ifinish=istart+many-1
      write(6,*) 'for l = ',l,' there are',many,' basis functions'
       do ib=istart,ifinish
        tphi(:,ib)=phi(:,ib)
        tp(:,ib)=0
       enddo
! form unorthonormalized projector functions tp
      write(6,*) '******* projector for l = ',l
      do ibase=istart,ifinish
      call bsolvtphi(n,iiirc,tphi(1,ibase),tp(1,ibase),rveff,veff0,r,h, &
           eval(ibase),l,ibase-istart,cp(ibase),shape)
          otp(1:n,ibase)=tp(1:n,ibase)
          ophi(1:n,ibase)=phi(1:n,ibase)
          otphi(1:n,ibase)=tphi(1:n,ibase)
      enddo
        !write(6,*) 'orthnormalization'
         do ibase=istart,ifinish
         do jbase=istart,ibase
          if (jbase.lt.ibase) then
           xx=overlap(n,h,otp(1,jbase),otphi(1,ibase))
           yy=overlap(n,h,otphi(1,jbase),otp(1,ibase))
           !write(6,*) 'before',jbase,ibase,xx,yy
            ophi(1:n,ibase)=ophi(1:n,ibase)-ophi(1:n,jbase)*xx
            otphi(1:n,ibase)=otphi(1:n,ibase)-otphi(1:n,jbase)*xx
            otp(1:n,ibase)=otp(1:n,ibase)-otp(1:n,jbase)*yy
          else if (jbase.eq.ibase) then
           xx=overlap(n,h,otp(1,jbase),otphi(1,ibase))
           yy=overlap(n,h,otphi(1,jbase),otp(1,ibase))
           !write(6,*) 'before',jbase,ibase,xx,yy
           choice=1.d0/sqrt(abs(xx))
           otp(1:n,ibase)=otp(1:n,ibase)*sign(choice,xx)
           otphi(1:n,ibase)=otphi(1:n,ibase)*choice
           ophi(1:n,ibase)=ophi(1:n,ibase)*choice
          endif
          enddo
          enddo

         do ibase=istart,ifinish
         do jbase=istart,ifinish
           xx=overlap(n,h,otp(1,jbase),otphi(1,ibase))
           yy=overlap(n,h,otphi(1,jbase),otp(1,ibase))
           !write(6,*) 'after',jbase,ibase,xx,yy
          enddo
          enddo

      istart=ifinish+1
      endif

      enddo
      return
       end
